## samba 4.13.13+dfsg

=== wscript ===
#!/usr/bin/env python

top = '.'
out = 'bin'

APPNAME='samba'
VERSION=None

import sys, os, tempfile
sys.path.insert(0, top+"/buildtools/wafsamba")
import shutil
import wafsamba, samba_dist, samba_git, samba_version, samba_utils
from waflib import Options, Scripting, Logs, Context, Errors

samba_dist.DIST_DIRS('.')
samba_dist.DIST_BLACKLIST('.gitignore .bzrignore source4/selftest/provisions')

# install in /usr/local/samba by default
default_prefix = Options.default_prefix = '/usr/local/samba'

# This callback optionally takes a list of paths as arguments:
# --with-system_mitkrb5 /path/to/krb5 /another/path
def system_mitkrb5_callback(option, opt, value, parser):
    setattr(parser.values, option.dest, True)
    value = []
    for arg in parser.rargs:
        # stop on --foo like options
        if arg[:2] == "--" and len(arg) > 2:
            break
        value.append(arg)
    if len(value)>0:
        del parser.rargs[:len(value)]
        setattr(parser.values, option.dest, value)

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('samba4')
    opt.RECURSE('lib/replace')
    opt.RECURSE('dynconfig')
    opt.RECURSE('packaging')
    opt.RECURSE('lib/ldb')
    opt.RECURSE('selftest')
    opt.RECURSE('source4/dsdb/samdb/ldb_modules')
    opt.RECURSE('pidl')
    opt.RECURSE('source3')
    opt.RECURSE('lib/util')
    opt.RECURSE('lib/crypto')
    opt.RECURSE('ctdb')

# Optional Libraries
# ------------------
#
# Most of the calls to opt.add_option() use default=True for the --with case
#
# To assist users and distributors to build Samba with the full feature
# set, the build system will abort if our dependent libraries and their
# header files are not found on the target system.  This will mean for
# example, that xattr, acl and ldap headers must be installed for the
# default build to complete.  The configure system will check for these
# headers, and the error message will indicate the option (such as
# --without-acl-support) that can be specified to skip this requirement.
#
# This will assist users and in particular distributors in building fully
# functional packages, while allowing those on systems truly without these
# facilities to continue to build Samba after careful consideration.
#
# It also ensures our container image generation in bootstrap/ is correct
# as otherwise a missing package there would just silently work

    opt.samba_add_onoff_option('pthreadpool', with_name="enable", without_name="disable", default=True)

    opt.add_option('--with-system-mitkrb5',
                   help='build Samba with system MIT Kerberos. ' +
                        'You may specify list of paths where Kerberos is installed (e.g. /usr/local /usr/kerberos) to search krb5-config',
                   action='callback', callback=system_mitkrb5_callback, dest='with_system_mitkrb5', default=False)

    opt.add_option('--with-experimental-mit-ad-dc',
                   help='Enable the experimental MIT Kerberos-backed AD DC.  ' +
                   'Note that security patches are not issued for this configuration',
                   action='store_true',
                   dest='with_experimental_mit_ad_dc',
                   default=False)

    opt.add_option('--with-system-mitkdc',
                   help=('Specify the path to the krb5kdc binary from MIT Kerberos'),
                   type="string",
                   dest='with_system_mitkdc',
                   default=None)

    opt.add_option('--with-system-heimdalkrb5',
                   help=('build Samba with system Heimdal Kerberos. ' +
                         'Requires --without-ad-dc' and
                         'conflicts with --with-system-mitkrb5'),
                   action='store_true',
                   dest='with_system_heimdalkrb5',
                   default=False)

    opt.add_option('--without-ad-dc',
                   help='disable AD DC functionality (enables only Samba FS (File Server, Winbind, NMBD) and client utilities.',
                   action='store_true', dest='without_ad_dc', default=False)

    opt.add_option('--with-ntvfs-fileserver',
                   help='enable the deprecated NTVFS file server from the original Samba4 branch (default if --enable-selftest specified).  Conflicts with --with-system-mitkrb5 and --without-ad-dc',
                   action='store_true', dest='with_ntvfs_fileserver')

    opt.add_option('--without-ntvfs-fileserver',
                   help='disable the deprecated NTVFS file server from the original Samba4 branch',
                   action='store_false', dest='with_ntvfs_fileserver')

    opt.add_option('--with-pie',
                  help=("Build Position Independent Executables " +
                        "(default if supported by compiler)"),
                  action="store_true", dest='enable_pie')
    opt.add_option('--without-pie',
                  help=("Disable Position Independent Executable builds"),
                  action="store_false", dest='enable_pie')

    opt.add_option('--with-relro',
                  help=("Build with full RELocation Read-Only (RELRO)" +
                        "(default if supported by compiler)"),
                  action="store_true", dest='enable_relro')
    opt.add_option('--without-relro',
                  help=("Disable RELRO builds"),
                  action="store_false", dest='enable_relro')

    gr = opt.option_group('developer options')

    opt.load('python') # options for disabling pyc or pyo compilation
    # enable options related to building python extensions

    opt.add_option('--with-json',
                   action='store_true', dest='with_json',
                   help=("Build with JSON support (default=True). This "
                         "requires the jansson development headers."))
    opt.add_option('--without-json',
                   action='store_false', dest='with_json',
                   help=("Build without JSON support."))

def configure(conf):
    version = samba_version.load_version(env=conf.env)

    conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
    conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.DEVELOPER = True
        # if we are in a git tree without a pre-commit hook, install a
        # simple default.
        # we need git for 'waf dist'
        githooksdir = None
        conf.find_program('git', var='GIT')
        if 'GIT' in conf.env:
            githooksdir = conf.CHECK_COMMAND('%s rev-parse --git-path hooks' % conf.env.GIT[0],
                               msg='Finding githooks directory',
                               define=None,
                               on_target=False)
        if githooksdir and os.path.isdir(githooksdir):
            pre_commit_hook = os.path.join(githooksdir, 'pre-commit')
            if not os.path.exists(pre_commit_hook):
                Logs.info("Installing script/git-hooks/pre-commit-hook as %s" %
                          pre_commit_hook)
                shutil.copy(os.path.join(Context.g_module.top, 'script/git-hooks/pre-commit-hook'),
                            pre_commit_hook)

    conf.ADD_EXTRA_INCLUDES('#include/public #source4 #lib #source4/lib #source4/include #include #lib/replace')

    conf.env.replace_add_global_pthread = True
    conf.RECURSE('lib/replace')

    conf.RECURSE('examples/fuse')
    conf.RECURSE('examples/winexe')

    conf.SAMBA_CHECK_PERL(mandatory=True)
    conf.find_program('xsltproc', var='XSLTPROC')

    if conf.env.disable_python:
        if not (Options.options.without_ad_dc):
            raise Errors.WafError('--disable-python requires --without-ad-dc')

    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    if sys.platform == 'darwin' and not conf.env['HAVE_ENVIRON_DECL']:
        # Mac OSX needs to have this and it's also needed that the python is compiled with this
        # otherwise you face errors about common symbols
        if not conf.CHECK_SHLIB_W_PYTHON("Checking if -fno-common is needed"):
            conf.ADD_CFLAGS('-fno-common')
        if not conf.CHECK_SHLIB_W_PYTHON("Checking if -undefined dynamic_lookup is not need"):
            conf.env.append_value('cshlib_LINKFLAGS', ['-undefined', 'dynamic_lookup'])

    if sys.platform == 'darwin':
        conf.ADD_LDFLAGS('-framework CoreFoundation')

    conf.RECURSE('dynconfig')
    conf.RECURSE('selftest')

    conf.CHECK_CFG(package='zlib', minversion='1.2.3',
                   args='--cflags --libs',
                   mandatory=True)
    conf.CHECK_FUNCS_IN('inflateInit2', 'z')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party')
    else:

        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

        if not conf.CHECK_CMOCKA():
            raise Errors.WafError('cmocka development packages has not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_CMOCKA', 1)

        if conf.CONFIG_GET('ENABLE_SELFTEST'):
            if not conf.CHECK_SOCKET_WRAPPER():
                raise Errors.WafError('socket_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_SOCKET_WRAPPER', 1)

            if not conf.CHECK_NSS_WRAPPER():
                raise Errors.WafError('nss_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_NSS_WRAPPER', 1)

            if not conf.CHECK_RESOLV_WRAPPER():
                raise Errors.WafError('resolv_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_RESOLV_WRAPPER', 1)

            if not conf.CHECK_UID_WRAPPER():
                raise Errors.WafError('uid_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_UID_WRAPPER', 1)

            if not conf.CHECK_PAM_WRAPPER():
                raise Errors.WafError('pam_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_PAM_WRAPPER', 1)

    conf.RECURSE('lib/ldb')

    if conf.CHECK_LDFLAGS(['-Wl,--wrap=test']):
        conf.env['HAVE_LDWRAP'] = True
        conf.define('HAVE_LDWRAP', 1)

    if not (Options.options.without_ad_dc):
        conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)

    if Options.options.with_system_mitkrb5:
        if not Options.options.with_experimental_mit_ad_dc and \
           not Options.options.without_ad_dc:
            raise Errors.WafError('The MIT Kerberos build of Samba as an AD DC ' +
                                  'is experimental. Therefore '
                                  '--with-system-mitkrb5 requires either ' +
                                  '--with-experimental-mit-ad-dc or ' +
                                  '--without-ad-dc')

        conf.PROCESS_SEPARATE_RULE('system_mitkrb5')

    if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
        conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)

    if Options.options.with_system_heimdalkrb5:
        if Options.options.with_system_mitkrb5:
            raise Errors.WafError('--with-system-heimdalkrb5 conflicts with ' +
                                  '--with-system-mitkrb5')
        if not Options.options.without_ad_dc:

=== ctdb/wscript ===
#!/usr/bin/env python

APPNAME = 'ctdb'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

from waflib import Options, Logs, Errors, Context
import wafsamba
from wafsamba import samba_dist, samba_utils
from samba_utils import MODE_644, MODE_744, MODE_755, MODE_777

if os.path.isfile('./VERSION'):
    vdir = '.'
elif os.path.isfile('../VERSION'):
    vdir = '..'
else:
    Logs.error("VERSION file not found")

default_prefix = Options.default_prefix = '/usr/local'

samba_dist.DIST_DIRS('''ctdb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tevent:lib/tevent lib/tdb:lib/tdb
                        third_party/socket_wrapper:third_party/socket_wrapper
                        third_party/popt:third_party/popt
                        lib/util:lib/util lib/tdb_wrap:lib/tdb_wrap
                        lib/ccan:lib/ccan libcli/util:libcli/util
                        lib/async_req:lib/async_req
                        lib/pthreadpool:lib/pthreadpool
                        lib/messaging:lib/messaging
                        buildtools:buildtools third_party/waf:third_party/waf''')

manpages_binary = [
    'ctdb.1',
    'ctdbd.1',
    'ltdbtool.1',
    'ping_pong.1'
]

manpages_misc = [
    'ctdb_diagnostics.1',
    'ctdbd_wrapper.1',
    'onnode.1',
    'ctdb.conf.5',
    'ctdb-script.options.5',
    'ctdb.sysconfig.5',
    'ctdb.7',
    'ctdb-statistics.7',
    'ctdb-tunables.7',
]

manpages_etcd = [
    'ctdb-etcd.7',
]

manpages_ceph = [
    'ctdb_mutex_ceph_rados_helper.7',
]

VERSION = ''

def get_version():
    import samba_version
    env = samba_utils.LOAD_ENVIRONMENT()

    return samba_version.samba_version_file('%s/VERSION' % vdir, vdir, env)

def get_version_string():
    if Context.g_module.VERSION:
        return Context.g_module.VERSION
    version = get_version()
    Context.g_module.VERSION = version.STRING.replace('-', '.')
    return Context.g_module.VERSION

def options(opt):
    opt.PRIVATE_EXTENSION_DEFAULT('ctdb')

    opt.RECURSE('lib/replace')

    opt.RECURSE('lib/util')

    opt.RECURSE('lib/talloc')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/tdb')

    opt.add_option('--enable-infiniband',
                   help=("Turn on infiniband support (default=no)"),
                   action="store_true", dest='ctdb_infiniband', default=False)
    opt.add_option('--enable-pmda',
                   help=("Turn on PCP pmda support (default=no)"),
                   action="store_true", dest='ctdb_pmda', default=False)
    opt.add_option('--enable-etcd-reclock',
                   help=("Enable etcd recovery lock helper (default=no)"),
                   action="store_true", dest='ctdb_etcd_reclock', default=False)

    opt.add_option('--with-libcephfs',
                   help=("Directory under which libcephfs is installed"),
                   action="store", dest='libcephfs_dir', default=None)
    opt.add_option('--enable-ceph-reclock',
                   help=("Enable Ceph CTDB recovery lock helper (default=no)"),
                   action="store_true", dest='ctdb_ceph_reclock', default=False)

    opt.add_option('--with-logdir',
                   help=("Path to log directory"),
                   action="store", dest='ctdb_logdir', default=None)
    opt.add_option('--with-socketpath',
                   help=("path to CTDB daemon socket"),
                   action="store", dest='ctdb_sockpath', default=None)


def configure(conf):
    # No need to build python bindings for talloc/tevent/tdb
    if conf.IN_LAUNCH_DIR():
        conf.env.standalone_ctdb = True
        Options.options.disable_python = True

    conf.RECURSE('lib/replace')

    conf.CHECK_HEADERS(headers='''sys/socket.h
                                  netinet/in.h
                                  netinet/if_ether.h
                                  netinet/ip.h
                                  netinet/ip6.h
                                  netinet/icmp6.h''',
                       together=True)

    conf.CHECK_CODE('int s = socket(AF_PACKET, SOCK_RAW, 0);',
                    define='HAVE_AF_PACKET',
                    headers='sys/socket.h linux/if_packet.h')

    conf.CHECK_CODE('struct sockaddr_ll sall; sall.sll_family = AF_PACKET;',
                    define='HAVE_PACKETSOCKET',
                    headers='sys/socket.h linux/if_packet.h')

    if conf.env.standalone_ctdb:
        conf.SAMBA_CHECK_PERL(mandatory=True)

        # This is just for consistency and to check the version for the
        # build system, see Options.options.disable_python = True above
        conf.SAMBA_CHECK_PYTHON()
        conf.SAMBA_CHECK_PYTHON_HEADERS()

        # We just want gnutls_rnd for rand subsystem
        conf.CHECK_FUNCS_IN('gnutls_rnd', 'gnutls')


    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        if conf.env.standalone_ctdb or conf.CONFIG_GET('ENABLE_SELFTEST'):
            conf.RECURSE('third_party/socket_wrapper')
            conf.env.SOCKET_WRAPPER_SO_PATH = conf.CONFIG_GET('LIBSOCKET_WRAPPER_SO_PATH')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)
        conf.env.SOCKET_WRAPPER_SO_PATH = ''


        if conf.env.standalone_ctdb or conf.CONFIG_GET('ENABLE_SELFTEST'):
            if not conf.CHECK_SOCKET_WRAPPER():
                raise Errors.WafError('socket_wrapper package has not been found.\nIf third_party is installed, check that it is in the proper place.')
            else:
                conf.define('USING_SYSTEM_SOCKET_WRAPPER', 1)
                conf.env.SOCKET_WRAPPER_SO_PATH = conf.CONFIG_GET('LIBSOCKET_WRAPPER_SO_PATH')

    conf.RECURSE('lib/util')

    conf.RECURSE('lib/talloc')
    conf.RECURSE('lib/tevent')
    conf.RECURSE('lib/tdb')

    conf.CHECK_HEADERS('sched.h')
    conf.CHECK_HEADERS('procinfo.h')
    if sys.platform.startswith('aix') and not conf.CHECK_FUNCS('thread_setsched'):
        Logs.error('Need thread_setsched() on AIX')
        sys.exit(1)
    elif not conf.CHECK_FUNCS('sched_setscheduler'):
        Logs.error('Need sched_setscheduler()')
        sys.exit(1)
    conf.CHECK_FUNCS('mlockall')
    conf.CHECK_FUNCS('getrusage', headers="sys/time.h sys/resource.h")

    if not conf.CHECK_VARIABLE('ETIME', headers='errno.h'):
        conf.DEFINE('ETIME', 'ETIMEDOUT')

    if sys.platform.startswith('linux'):
        conf.SET_TARGET_TYPE('pcap', 'EMPTY')
    else:
        if not conf.CHECK_HEADERS('pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)
        if not conf.CHECK_FUNCS_IN('pcap_open_live', 'pcap', headers='pcap.h'):
            Logs.error('Need libpcap')
            sys.exit(1)

    if not conf.CHECK_FUNCS_IN('backtrace backtrace_symbols', 'execinfo',
                               checklibc=True, headers='execinfo.h'):
        Logs.error('backtrace support not available')

    have_pmda = False
    if Options.options.ctdb_pmda:
        pmda_support = True

        if not conf.CHECK_HEADERS('pcp/pmapi.h pcp/impl.h pcp/pmda.h',
                                  together=True):
            pmda_support = False
        if not conf.CHECK_FUNCS_IN('pmProgname', 'pcp'):
            pmda_support = False
        if not conf.CHECK_FUNCS_IN('pmdaDaemon', 'pcp_pmda'):
            pmda_support = False
        if pmda_support:
            conf.CHECK_TYPE_IN('__pmID_int', 'pcp/pmapi.h pcp/impl.h')
            have_pmda = True
        else:
            Logs.error("PMDA support not available")
            sys.exit(1)
    if have_pmda:
        Logs.info('Building with PMDA support')
        conf.define('HAVE_PMDA', 1)
        conf.env.CTDB_PMDADIR = os.path.join(conf.env.LOCALSTATEDIR,
                                             'lib/pcp/pmdas/ctdb')

    have_infiniband = False
    if Options.options.ctdb_infiniband:
        ib_support = True

        if not conf.CHECK_HEADERS('infiniband/verbs.h rdma/rdma_cma.h'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('ibv_create_qp', 'ibverbs'):
            ib_support = False
        if not conf.CHECK_FUNCS_IN('rdma_connect', 'rdmacm'):
            ib_support = False
        if ib_support:
            have_infiniband = True
        else:
            Logs.error("Infiniband support not available")
            sys.exit(1)
    if have_infiniband:
        Logs.info('Building with Infiniband support')
        conf.define('HAVE_INFINIBAND', 1)
        conf.define('USE_INFINIBAND', 1)

    have_etcd_reclock = False
    if Options.options.ctdb_etcd_reclock:
        try:
            conf.check_python_module('etcd')
            have_etcd_reclock = True
        except:
            Logs.error('etcd support not available')
            sys.exit(1)
    if have_etcd_reclock:
        Logs.info('Building with etcd support')
    conf.env.etcd_reclock = have_etcd_reclock

    if Options.options.libcephfs_dir:
        Logs.error('''--with-libcephfs no longer supported, please use compiler
                   flags instead, e.g. GCC LIBRARY_PATH and C_INCLUDE_PATH''')
        sys.exit(1)

    if Options.options.ctdb_ceph_reclock:
        if (conf.CHECK_HEADERS('rados/librados.h', False, False, 'rados') and
					conf.CHECK_LIB('rados', shlib=True)):
            Logs.info('Building with Ceph librados recovery lock support')
            conf.define('HAVE_LIBRADOS', 1)
        else:
            Logs.error("Missing librados for Ceph recovery lock support")
            sys.exit(1)

    conf.env.CTDB_BINDIR = os.path.join(conf.env.EXEC_PREFIX, 'bin')
    conf.env.CTDB_DATADIR = os.path.join(conf.env.EXEC_PREFIX, 'share/ctdb')
    conf.env.CTDB_ETCDIR = os.path.join(conf.env.SYSCONFDIR, 'ctdb')
    conf.env.CTDB_VARDIR = os.path.join(conf.env.LOCALSTATEDIR, 'lib/ctdb')
    conf.env.CTDB_RUNDIR = os.path.join(conf.env.LOCALSTATEDIR, 'run/ctdb')
    conf.env.CTDB_HELPER_BINDIR = os.path.join(conf.env.LIBEXECDIR, 'ctdb')

    if Options.options.ctdb_logdir:
        conf.env.CTDB_LOGDIR = Options.options.ctdb_logdir
    else:
        conf.env.CTDB_LOGDIR = os.path.join(conf.env.LOCALSTATEDIR, 'log')

    if Options.options.ctdb_sockpath:
        conf.env.CTDB_SOCKPATH = Options.options.ctdb_sockpath
    else:
        conf.env.CTDB_SOCKPATH = os.path.join(conf.env.CTDB_RUNDIR,
                                              'ctdbd.socket')
    conf.define('CTDB_SOCKET', conf.env.CTDB_SOCKPATH)

    conf.ADD_CFLAGS('''-DCTDB_HELPER_BINDIR=\"%s\"
                       -DLOGDIR=\"%s\"
                       -DCTDB_DATADIR=\"%s\"
                       -DCTDB_ETCDIR=\"%s\"
                       -DCTDB_VARDIR=\"%s\"
                       -DCTDB_RUNDIR=\"%s\"''' % (
                    conf.env.CTDB_HELPER_BINDIR,
                    conf.env.CTDB_LOGDIR,
                    conf.env.CTDB_DATADIR,
                    conf.env.CTDB_ETCDIR,
                    conf.env.CTDB_VARDIR,
                    conf.env.CTDB_RUNDIR))

    conf.env.CTDB_TEST_DATADIR = os.path.join(conf.env.CTDB_DATADIR, 'tests')
    conf.env.CTDB_TEST_LIBEXECDIR = os.path.join(conf.env.LIBEXECDIR, 'ctdb/tests')

    # Allow unified compilation and separate compilation of utilities
    # to find includes
    if not conf.env.standalone_ctdb:
        conf.ADD_EXTRA_INCLUDES('#include/public #ctdb/include #ctdb')
    else:
        if Context.g_module.top == '.':
            # Building from tarball
            conf.ADD_EXTRA_INCLUDES('#include')
        else:
            # Building standalone CTDB from within Samba tree
            conf.ADD_EXTRA_INCLUDES('#ctdb/include')
            conf.ADD_EXTRA_INCLUDES('#ctdb')
        conf.ADD_EXTRA_INCLUDES('#lib #lib/replace')

=== dynconfig/wscript ===
#!/usr/bin/env python

import string
import os
import optparse
import textwrap
from waflib import Logs, Errors, Options, Build, Context
from samba_utils import EXPAND_VARIABLES

class SambaIndentedHelpFormatter (optparse.IndentedHelpFormatter):
    """Format help with indented section bodies.
    """

    def __init__(self,
                 indent_increment=2,
                 max_help_position=12,
                 width=None,
                 short_first=1):
        optparse.IndentedHelpFormatter.__init__(
            self, indent_increment, max_help_position, width, short_first)

    def format_option(self, option):
        # The help for each option consists of two parts:
        #   * the opt strings and metavars
        #     eg. ("-x", or "-fFILENAME, --file=FILENAME")
        #   * the user-supplied help string
        #     eg. ("turn on expert mode", "read data from FILENAME")
        #
        # If possible, we write both of these on the same line:
        #   -x      turn on expert mode
        #
        # But if the opt string list is too long, we put the help
        # string on a second line, indented to the same column it would
        # start in if it fit on the first line.
        #   -fFILENAME, --file=FILENAME
        #           read data from FILENAME
        result = []
        opts = self.option_strings[option]
        opt_width = self.help_position - self.current_indent - 2
        if len(opts) > opt_width:
            opts = "%*s%s\n" % (self.current_indent, "", opts)
            indent_first = self.help_position
        else:                       # start help on same line as opts
            opts = "%*s%-*s  " % (self.current_indent, "", opt_width, opts)
            indent_first = 0
        result.append(opts)
        if option.help:
            help_text = self.expand_default(option)
            if help_text.find('\n') == -1:
                help_lines = textwrap.wrap(help_text, self.help_width)
            else:
                help_lines = help_text.splitlines()
            result.append("%*s%s\n" % (indent_first, "", help_lines[0]))
            result.extend(["%*s%s\n" % (self.help_position, "", line)
                           for line in help_lines[1:]])
        elif opts[-1] != "\n":
            result.append("\n")
        return "".join(result)


# list of directory options to offer in configure
#
# 'STD-PATH'  - the default path without --enable-fhs
# 'FHS-PATH'  - the default path with --enable-fhs
#
# 'OPTION'    - the configure option to overwrite the default (optional)
# 'HELPTEXT'  - the help text of the configure option (optional)
#
# 'OVERWRITE' - The option refers to itself and was already from
#               the basic GNU options from the gnu_dirs tool.
#               We may overwrite the related path. (Default: False)
#
# 'DELAY'     - The option refers to other options in the dynconfig list.
#               We delay the initalization into a later stage. This
#               makes sure the recursion works. (Default: False)
#
dynconfig = {
    'BINDIR' : {
         'STD-PATH':  '${BINDIR}',
         'FHS-PATH':  '${BINDIR}',
         'OVERWRITE': True,
    },
    'SBINDIR' : {
         'STD-PATH':  '${SBINDIR}',
         'FHS-PATH':  '${SBINDIR}',
         'OVERWRITE': True,
    },
    'LIBDIR' : {
         'STD-PATH':  '${LIBDIR}',
         'FHS-PATH':  '${LIBDIR}',
         'OVERWRITE': True,
    },
    'LIBEXECDIR' : {
         'STD-PATH':  '${LIBEXECDIR}',
         'FHS-PATH':  '${LIBEXECDIR}',
         'OVERWRITE': True,
    },
    'DATADIR' : {
         'STD-PATH':  '${DATADIR}',
         'FHS-PATH':  '${DATADIR}',
         'OVERWRITE': True,
    },
    'SAMBA_DATADIR' : {
         'STD-PATH':  '${DATADIR}/samba',
         'FHS-PATH':  '${DATADIR}/samba',
         'OVERWRITE': True,
    },
    'LOCALEDIR' : {
         'STD-PATH':  '${LOCALEDIR}',
         'FHS-PATH':  '${LOCALEDIR}',
         'OVERWRITE': True,
    },
    'PYTHONDIR' : {
         'STD-PATH':  '${PYTHONDIR}',
         'FHS-PATH':  '${PYTHONDIR}',
         'OVERWRITE': True,
    },
    'PYTHONARCHDIR' : {
         'STD-PATH':  '${PYTHONARCHDIR}',
         'FHS-PATH':  '${PYTHONARCHDIR}',
         'OVERWRITE': True,
    },
    'PERL_LIB_INSTALL_DIR' : {
         'STD-PATH':  '${PERL_LIB_INSTALL_DIR}',
         'FHS-PATH':  '${PERL_LIB_INSTALL_DIR}',
         'OVERWRITE': True,
    },
    'PERL_ARCH_INSTALL_DIR' : {
         'STD-PATH':  '${PERL_ARCH_INSTALL_DIR}',
         'FHS-PATH':  '${PERL_ARCH_INSTALL_DIR}',
         'OVERWRITE': True,
    },
    'INCLUDEDIR' : {
         'STD-PATH':  '${INCLUDEDIR}',
         'FHS-PATH':  '${INCLUDEDIR}/samba-4.0',
         'OVERWRITE': True,
    },
    'SCRIPTSBINDIR' : {
         'STD-PATH':  '${SBINDIR}',
         'FHS-PATH':  '${SBINDIR}',
    },
    'SETUPDIR' : {
         'STD-PATH':  '${DATADIR}/setup',
         'FHS-PATH':  '${DATADIR}/samba/setup',
    },
    'PKGCONFIGDIR' : {
         'STD-PATH':  '${LIBDIR}/pkgconfig',
         'FHS-PATH':  '${LIBDIR}/pkgconfig',
    },
    'CODEPAGEDIR' : {
         'STD-PATH':  '${DATADIR}/codepages',
         'FHS-PATH':  '${DATADIR}/samba/codepages',
    },
    'PRIVATELIBDIR' : {
         'STD-PATH':  '${LIBDIR}/private',
         'FHS-PATH':  '${LIBDIR}/samba',
         'OPTION':    '--with-privatelibdir',
         'HELPTEXT':  'Which directory to use for private Samba libraries',
         'OVERWRITE': True,
    },
    'MODULESDIR' : {
         'STD-PATH':  '${LIBDIR}',
         'FHS-PATH':  '${LIBDIR}/samba',
         'OPTION':    '--with-modulesdir',
         'HELPTEXT':  'Which directory to use for Samba modules',
         'OVERWRITE': True,
    },
    'PAMMODULESDIR' : {
         'STD-PATH':  '${LIBDIR}/security',
         'FHS-PATH':  '${LIBDIR}/security',
         'OPTION':    '--with-pammodulesdir',
         'HELPTEXT':  'Which directory to use for PAM modules',
    },
    'CONFIGDIR' : {
         'STD-PATH':  '${SYSCONFDIR}',
         'FHS-PATH':  '${SYSCONFDIR}/samba',
         'OPTION':    '--with-configdir',
         'HELPTEXT':  'Where to put configuration files',
    },
    'PRIVATE_DIR' : {
         'STD-PATH':  '${PREFIX}/private',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba/private',
         'OPTION':    '--with-privatedir',
         'HELPTEXT':  'Where to put sam.ldb and other private files',
    },
    'BINDDNS_DIR' : {
         'STD-PATH':  '${PREFIX}/bind-dns',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba/bind-dns',
         'OPTION':    '--with-bind-dns-dir',
         'HELPTEXT':  'bind-dns config directory',
    },
    'LOCKDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/lock',
         'FHS-PATH':  '${LOCALSTATEDIR}/lock/samba',
         'OPTION':    '--with-lockdir',
         'HELPTEXT':  'Where to put short term disposable state files',
    },
    'PIDDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/run',
         'FHS-PATH':  '${LOCALSTATEDIR}/run/samba',
         'OPTION':    '--with-piddir',
         'HELPTEXT':  'Where to put pid files',
    },
    'STATEDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/locks',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba',
         'OPTION':    '--with-statedir',
         'HELPTEXT':  'Where to put persistent state files',
    },
    'CACHEDIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/cache',
         'FHS-PATH':  '${LOCALSTATEDIR}/cache/samba',
         'OPTION':    '--with-cachedir',
         'HELPTEXT':  'Where to put temporary cache files',
    },
    'LOGFILEBASE' : {
         'STD-PATH':  '${LOCALSTATEDIR}',
         'FHS-PATH':  '${LOCALSTATEDIR}/log/samba',
         'OPTION':    '--with-logfilebase',
         'HELPTEXT':  'Where to put log files',
    },
    'SOCKET_DIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/run',
         'FHS-PATH':  '${LOCALSTATEDIR}/run/samba',
         'OPTION':    '--with-sockets-dir',
         'HELPTEXT':  'socket directory',
    },
    'PRIVILEGED_SOCKET_DIR' : {
         'STD-PATH':  '${LOCALSTATEDIR}/lib',
         'FHS-PATH':  '${LOCALSTATEDIR}/lib/samba',
         'OPTION':    '--with-privileged-socket-dir',
         'HELPTEXT':  'privileged socket directory',
    },
    'WINBINDD_SOCKET_DIR' : {
         'STD-PATH':  '${SOCKET_DIR}/winbindd',
         'FHS-PATH':  '${SOCKET_DIR}/winbindd',
         'DELAY':     True,
    },
    'NMBDSOCKETDIR' : {
         'STD-PATH':  '${SOCKET_DIR}/nmbd',
         'FHS-PATH':  '${SOCKET_DIR}/nmbd',
         'DELAY':     True,
    },
    'NTP_SIGND_SOCKET_DIR' : {
         'STD-PATH':  '${PRIVILEGED_SOCKET_DIR}/ntp_signd',
         'FHS-PATH':  '${PRIVILEGED_SOCKET_DIR}/ntp_signd',
         'DELAY':     True,
    },
    'NCALRPCDIR' : {
         'STD-PATH':  '${SOCKET_DIR}/ncalrpc',
         'FHS-PATH':  '${SOCKET_DIR}/ncalrpc',
         'DELAY':     True,
    },
    'CONFIGFILE' : {
         'STD-PATH':  '${CONFIGDIR}/smb.conf',
         'FHS-PATH':  '${CONFIGDIR}/smb.conf',
         'DELAY':     True,
    },
    'LMHOSTSFILE' : {
         'STD-PATH':  '${CONFIGDIR}/lmhosts',
         'FHS-PATH':  '${CONFIGDIR}/lmhosts',
         'DELAY':     True,
    },
    'SMB_PASSWD_FILE' : {
         'STD-PATH':  '${PRIVATE_DIR}/smbpasswd',
         'FHS-PATH':  '${PRIVATE_DIR}/smbpasswd',
         'OPTION':    '--with-smbpasswd-file',
         'HELPTEXT':  'Where to put the smbpasswd file',
         'DELAY':     True,
    },
}

def options(opt):
    opt.parser.formatter = SambaIndentedHelpFormatter()
    opt.parser.formatter.width=Logs.get_term_cols()

    for k in ('--with-privatelibdir', '--with-modulesdir'):
        option = opt.parser.get_option(k)
        if option:
            opt.parser.remove_option(k)
    del opt.parser.defaults['PRIVATELIBDIR']
    del opt.parser.defaults['MODULESDIR']

    # get all the basic GNU options from the gnu_dirs tool

    opt_group=opt.add_option_group('Samba-specific directory layout','')

    fhs_help  = "Use FHS-compliant paths (default no)\n"
    fhs_help += "You should consider using this together with:\n"
    fhs_help += "--prefix=/usr --sysconfdir=/etc --localstatedir=/var"
    opt_group.add_option('--enable-fhs', help=fhs_help,
                   action="store_true", dest='ENABLE_FHS', default=False)

    for varname in dynconfig.keys():
        if 'OPTION' not in dynconfig[varname]:
            continue
        opt = dynconfig[varname]['OPTION']
        if 'HELPTEXT' in dynconfig[varname]:
            txt = dynconfig[varname]['HELPTEXT']
        else:
            txt = "dynconfig path %s" % (varname)
        def_std = dynconfig[varname]['STD-PATH']
        def_fhs = dynconfig[varname]['FHS-PATH']

        help = "%s\n[STD-Default: %s]\n[FHS-Default: %s]" % (txt, def_std, def_fhs)
        opt_group.add_option(opt, help=help, dest=varname, action="store")

def configure(conf):
    # get all the basic GNU options from the gnu_dirs tool

    if Options.options.ENABLE_FHS:
        flavor = 'FHS-PATH'
    else:
        flavor = 'STD-PATH'
        if conf.env.PREFIX == '/usr' or conf.env.PREFIX == '/usr/local':
           Logs.error("Don't install directly under /usr or /usr/local without using the FHS option (--enable-fhs)")
           raise Errors.WafError("ERROR: invalid --prefix=%s value" % (conf.env.PREFIX))

    explicit_set ={}

    dyn_vars = {}
    for varname in dynconfig.keys():
        dyn_vars[varname] = dynconfig[varname][flavor]
        if 'OVERWRITE' in dynconfig[varname] and dynconfig[varname]['OVERWRITE']:
            # we may overwrite this option
            continue
        conf.ASSERT(varname not in conf.env, "Variable %s already defined" % varname)

    # the explicit block
    for varname in dynconfig.keys():
        if 'OPTION' not in dynconfig[varname]:
            continue
        value = getattr(Options.options, varname, None)
        if value is None:
           continue
        conf.ASSERT(value != '', "Empty dynconfig value for %s" % varname)
        conf.env[varname] = value
        # mark it as explicit from the command line

=== python/wscript ===
#!/usr/bin/env python

import os

def configure(conf):
    if conf.env.disable_python:
        return

    kerberos_py = conf.srcnode.abspath() + "/python/samba/provision/kerberos_implementation.py"

    f = open(kerberos_py, 'w')
    try:
        header = """#
# Copyright (c) 2016      Andreas Schneider <asn@samba.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
"""
        f.write(header)

        data = """kdb_modules_dir = "{0}"
"""

        if conf.env.HEIMDAL_KRB5_CONFIG:
            f.write(data.format("", ""))
        else:
            modulesdir = "%s/krb5/plugins/kdb" % conf.env.LIBDIR

            f.write(data.format(modulesdir))
    finally:
        f.close()

def build(bld):


    pytalloc_util = bld.pyembed_libname('pytalloc-util')
    pyparam_util = bld.pyembed_libname('pyparam_util')
    libpython = bld.pyembed_libname('LIBPYTHON')
    pyrpc_util = bld.pyembed_libname('pyrpc_util')
    samba_python = bld.pyembed_libname('samba_python')
    bld.SAMBA_LIBRARY(samba_python,
                      source=[],
                      deps='%s %s %s' % (libpython, pytalloc_util, pyrpc_util),
                      grouping_library=True,
                      private_library=True,
                      pyembed=True,
                      enabled=bld.PYTHON_BUILD_IS_ENABLED())
    bld.SAMBA_PYTHON('python_glue',
                     source='pyglue.c',
                     deps='''
                              %s
                              samba-util
                              netif
                              %s
                              ''' % (pyparam_util, pytalloc_util),
                     realname='samba/_glue.so')

    bld.SAMBA_SUBSYSTEM(libpython,
                        source='modules.c',
                        public_deps='',
                        init_function_sentinel='{NULL,NULL}',
                        deps='talloc',
                        pyext=True,
                        enabled=bld.PYTHON_BUILD_IS_ENABLED())

    if bld.PYTHON_BUILD_IS_ENABLED():
        # install out various python scripts for use by make test
        bld.SAMBA_SCRIPT('samba_python_files',
                         pattern='samba/**/*.py',
                         installdir='python')
        
        bld.INSTALL_WILDCARD('${PYTHONARCHDIR}', 'samba/**/*.py', flat=False)

=== selftest/wscript ===
#!/usr/bin/env python
# vim: expandtab ft=python

# selftest main code.

import sys
import os
import optparse
from waflib import Scripting, Options, Utils
from waflib.ConfigSet import ConfigSet as Environment

from samba_utils import *
from samba_autoconf import *
import types

DEFAULT_SELFTEST_PREFIX="./st"

def options(opt):

    opt.add_option('--enable-selftest',
                   help=("enable options necessary for selftest (default=no)"),
                   action="store_true", dest='enable_selftest', default=False)
    opt.add_option('--with-selftest-prefix',
                   help=("specify location of selftest directory "
                         "(default=%s)" % DEFAULT_SELFTEST_PREFIX),
                   action="store", dest='SELFTEST_PREFIX', default=DEFAULT_SELFTEST_PREFIX)

    opt.ADD_COMMAND('test', cmd_test)
    opt.ADD_COMMAND('testonly', cmd_testonly)

    gr = opt.add_option_group('test options')

    gr.add_option('--load-list',
                  help=("Load a test id list from a text file"),
                  action="store", dest='LOAD_LIST', default=None)
    gr.add_option('--list',
                  help=("List available tests"),
                  action="store_true", dest='LIST', default=False)
    gr.add_option('--tests',
                  help=("wildcard pattern of tests to run"),
                  action="store", dest='TESTS', default='')
    gr.add_option('--filtered-subunit',
                  help=("output (xfail) filtered subunit"),
                  action="store_true", dest='FILTERED_SUBUNIT', default=False)
    gr.add_option('--quick',
                  help=("enable only quick tests"),
                  action="store_true", dest='QUICKTEST', default=False)
    gr.add_option('--slow',
                  help=("enable the really slow tests"),
                  action="store_true", dest='SLOWTEST', default=False)
    gr.add_option('--nb-slowest',
                  help=("Show the n slowest tests (default=10)"),
                  type=int, default=10, dest='NB_SLOWEST')
    gr.add_option('--testenv',
                  help=("start a terminal with the test environment setup"),
                  action="store_true", dest='TESTENV', default=False)
    gr.add_option('--valgrind',
                  help=("use valgrind on client programs in the tests"),
                  action="store_true", dest='VALGRIND', default=False)
    gr.add_option('--valgrind-log',
                  help=("where to put the valgrind log"),
                  action="store", dest='VALGRINDLOG', default=None)
    gr.add_option('--valgrind-server',
                  help=("use valgrind on the server in the tests (opens an xterm)"),
                  action="store_true", dest='VALGRIND_SERVER', default=False)
    gr.add_option('--screen',
                  help=("run the samba servers in screen sessions"),
                  action="store_true", dest='SCREEN', default=False)
    gr.add_option('--gdbtest',
                  help=("run the servers within a gdb window"),
                  action="store_true", dest='GDBTEST', default=False)
    gr.add_option('--fail-immediately',
                  help=("stop tests on first failure"),
                  action="store_true", dest='FAIL_IMMEDIATELY', default=False)
    gr.add_option('--socket-wrapper-pcap',
                  help=("create a pcap file for each failing test"),
                  action="store_true", dest='SOCKET_WRAPPER_PCAP', default=False)
    gr.add_option('--socket-wrapper-keep-pcap',
                  help=("create a pcap file for all individual test"),
                  action="store_true", dest='SOCKET_WRAPPER_KEEP_PCAP', default=False)
    gr.add_option('--random-order', dest='RANDOM_ORDER', default=False,
                  action="store_true", help="Run testsuites in random order")
    gr.add_option('--perf-test', dest='PERF_TEST', default=False,
                  action="store_true", help="run performance tests only")
    gr.add_option('--test-list', dest='TEST_LIST', default='',
                  help=("use tests listed here, not defaults "
                        "(--test-list='FOO|' will execute FOO; "
                        "--test-list='FOO' will read it)"))
    gr.add_option('--no-subunit-filter',
                  help=("no (xfail) subunit filtering"),
                  action="store_true", dest='NO_SUBUNIT_FILTER', default=False)


def configure(conf):
    conf.env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX
    if Options.options.enable_selftest or Options.options.developer:
        conf.DEFINE('ENABLE_SELFTEST', 1)


def cmd_testonly(opt):
    '''run tests without doing a build first'''
    env = LOAD_ENVIRONMENT()
    opt.env = env

    if Options.options.SELFTEST_PREFIX != DEFAULT_SELFTEST_PREFIX:
        env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX

    if (not CONFIG_SET(opt, 'NSS_WRAPPER') or
        not CONFIG_SET(opt, 'UID_WRAPPER') or
        not CONFIG_SET(opt, 'SOCKET_WRAPPER')):
        print("ERROR: You must use --enable-selftest to enable selftest")
        sys.exit(1)

    os.environ['SAMBA_SELFTEST'] = '1'

    env.TESTS  = Options.options.TESTS

    env.SUBUNIT_FORMATTER = os.getenv('SUBUNIT_FORMATTER')

    # Lots of test scripts need to run with the correct version
    # of python. With the correct shebang the script should run with the
    # correct version, the problem is that not all scripts are part
    # of the installation, some scripts are part of the source code,
    # and the shebang is not dynamically generated as yet.
    # It is safer if we are somewhat version neutral at the moment and
    # ignore the shebang and always run scripts from the test environment
    # with the python version (determined by PYTHON env variable) If this
    # env variable isn't set then set it according to the python version
    # that is running the tests
    if not os.getenv('PYTHON', None):
        from sys import executable as exe
        os.environ['PYTHON'] = os.path.basename(exe)

    if not env.SUBUNIT_FORMATTER:
        if Options.options.PERF_TEST:
            env.SUBUNIT_FORMATTER = '${PYTHON} -u ${srcdir}/selftest/format-subunit-json --prefix=${SELFTEST_PREFIX}'
        else:
            env.SUBUNIT_FORMATTER = '${PYTHON} -u ${srcdir}/selftest/format-subunit --prefix=${SELFTEST_PREFIX} --immediate'
    env.FILTER_XFAIL = ('${PYTHON} -u ${srcdir}/selftest/filter-subunit '
                        '--expected-failures=${srcdir}/selftest/knownfail '
                        '--expected-failures=${srcdir}/selftest/knownfail.d '
                        '--flapping=${srcdir}/selftest/flapping '
                        '--flapping=${srcdir}/selftest/flapping.d')

    if CONFIG_GET(opt, 'HAVE_MIT_KRB5_PRE_1_18'):
        env.FILTER_XFAIL += ' --expected-failures=${srcdir}/selftest/knownfail_mit_krb5_pre_1_18'

    if Options.options.FAIL_IMMEDIATELY:
        env.FILTER_XFAIL += ' --fail-immediately'

    env.FORMAT_TEST_OUTPUT = '${SUBUNIT_FORMATTER}'

    # clean any previous temporary files
    os.system("rm -rf %s/tmp" % env.SELFTEST_PREFIX);

    # put all command line options in the environment as TESTENV_*=*
    for o in dir(Options.options):
        if o[0:1] != '_':
            val = getattr(Options.options, o, '')
            if not issubclass(type(val), types.FunctionType) \
                    and not issubclass(type(val), types.MethodType):
                os.environ['TESTENV_%s' % o.upper()] = str(getattr(Options.options, o, ''))

    env.OPTIONS = ''
    if not Options.options.SLOWTEST:
        env.OPTIONS += ' --exclude=${srcdir}/selftest/slow'
    if Options.options.QUICKTEST:
        env.OPTIONS += ' --quick --include=${srcdir}/selftest/quick'
    if Options.options.LOAD_LIST:
        env.OPTIONS += ' --load-list=%s' % Options.options.LOAD_LIST
    if Options.options.TESTENV:
        env.OPTIONS += ' --testenv'
    if Options.options.SOCKET_WRAPPER_PCAP:
        env.OPTIONS += ' --socket-wrapper-pcap'
    if Options.options.SOCKET_WRAPPER_KEEP_PCAP:
        env.OPTIONS += ' --socket-wrapper-keep-pcap'
    if Options.options.RANDOM_ORDER:
        env.OPTIONS += ' --random-order'
    if Options.options.PERF_TEST:
        env.FILTER_OPTIONS = ('${PYTHON} -u ${srcdir}/selftest/filter-subunit '
                              '--perf-test-output')
    else:
        env.FILTER_OPTIONS = '${FILTER_XFAIL}'

    if Options.options.VALGRIND:
        os.environ['VALGRIND'] = 'valgrind -q --num-callers=30'
        if Options.options.VALGRINDLOG is not None:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

    server_wrapper=''

    if Options.options.VALGRIND_SERVER:
        server_wrapper = '${srcdir}/selftest/valgrind_run _DUMMY=X'
    elif Options.options.GDBTEST:
        server_wrapper = '${srcdir}/selftest/gdb_run _DUMMY=X'

    if Options.options.SCREEN:
        server_wrapper = '${srcdir}/selftest/in_screen %s' % server_wrapper
        os.environ['TERMINAL'] = EXPAND_VARIABLES(opt, '${srcdir}/selftest/in_screen')
    elif server_wrapper != '':
        server_wrapper = 'xterm -n server -l -e %s' % server_wrapper

    if server_wrapper != '':
        os.environ['SAMBA_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['NMBD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['WINBINDD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)
        os.environ['SMBD_VALGRIND'] = EXPAND_VARIABLES(opt, server_wrapper)

    # this is needed for systems without rpath, or with rpath disabled
    ADD_LD_LIBRARY_PATH('bin/shared')
    ADD_LD_LIBRARY_PATH('bin/shared/private')

    # if we are using a system version of ldb then we need to tell it to
    # load modules from our modules path
    if env.USING_SYSTEM_LDB:
        os.environ['LDB_MODULES_PATH'] = os.path.abspath(
                os.path.join(*(env.cwd + ['bin/modules/ldb'])))

    # tell build system where to find config.h
    os.environ['CONFIG_H'] = 'bin/default/include/config.h'

    # tell the test system where perl is
    if isinstance(env.PERL, list):
        perl = ' '.join(env.PERL)
    else:
        perl = env.PERL
    os.environ['PERL'] = perl

    st_done = os.path.join(env.SELFTEST_PREFIX, 'st_done')
    if os.path.exists(st_done):
        os.unlink(st_done)

    if not os.path.isdir(env.SELFTEST_PREFIX):
        os.makedirs(env.SELFTEST_PREFIX, int('755', 8))

    if Options.options.TEST_LIST:
        env.TESTLISTS = '--testlist=%r' % Options.options.TEST_LIST
    elif Options.options.PERF_TEST:
        env.TESTLISTS = '--testlist="${PYTHON} ${srcdir}/selftest/perf_tests.py|" '
    else:
        env.TESTLISTS = ('--testlist="${PYTHON} ${srcdir}/selftest/tests.py|" ' +
                         '--testlist="${PYTHON} ${srcdir}/source3/selftest/tests.py|" ' +
                         '--testlist="${PYTHON} ${srcdir}/source4/selftest/tests.py|"')

    if CONFIG_SET(opt, 'AD_DC_BUILD_IS_ENABLED'):
        env.SELFTEST_TARGET = "samba"
    else:
        env.SELFTEST_TARGET = "samba3"

    env.OPTIONS += " --nss_wrapper_so_path=" + CONFIG_GET(opt, 'LIBNSS_WRAPPER_SO_PATH')
    env.OPTIONS += " --resolv_wrapper_so_path=" + CONFIG_GET(opt, 'LIBRESOLV_WRAPPER_SO_PATH')
    env.OPTIONS += " --uid_wrapper_so_path=" + CONFIG_GET(opt, 'LIBUID_WRAPPER_SO_PATH')

    # selftest can optionally use kernel namespaces instead of socket-wrapper
    if os.environ.get('USE_NAMESPACES') is None:
        env.OPTIONS += " --socket_wrapper_so_path=" + CONFIG_GET(opt, 'LIBSOCKET_WRAPPER_SO_PATH')

    if Utils.unversioned_sys_platform() in ('netbsd', 'openbsd', 'sunos'):
        env.OPTIONS += " --use-dns-faking"

    if CONFIG_GET(opt, 'USING_SYSTEM_KRB5') and CONFIG_GET(opt, 'MIT_KDC_PATH'):
        env.OPTIONS += " --mitkrb5 --exclude=${srcdir}/selftest/skip_mit_kdc"
        env.FILTER_XFAIL += " --expected-failures=${srcdir}/selftest/"\
                            "knownfail_mit_kdc"
    else:

=== source3/wscript ===
#!/usr/bin/env python

srcdir = ".."

import sys, os
from optparse import SUPPRESS_HELP
sys.path.insert(0, srcdir + "/buildtools/wafsamba")
sys.path.insert(0, "source3")

from waflib import Options, Logs, Errors
import wafsamba
import build.charset
from wafsamba import samba_utils
from samba_utils import TO_LIST
import samba3
from waflib.Tools import bison

default_prefix = Options.default_prefix = '/usr/local/samba'

def options(opt):

    opt.add_option('--with-static-modules',
                   help=("Comma-separated list of names of modules to statically link in. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required static only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a static build. "+
                         "Can be 'ALL' to build all default shared modules static. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='static_modules', default=None)
    opt.add_option('--with-shared-modules',
                   help=("Comma-separated list of names of modules to build shared. "+
                         "May include !module to disable 'module'. "+
                         "Can be '!FORCED' to disable all non-required shared only modules. "+
                         "Can be '!DEFAULT' to disable all modules defaulting to a shared build. "+
                         "Can be 'ALL' to build all default static modules shared. "+
                         "The most specific one wins, while the order is ignored "+
                         "and --with-static-modules is evaluated before "+
                         "--with-shared-modules"),
                   action="store", dest='shared_modules', default=None)

# Optional Libraries
# ------------------
#
# Most of the calls to opt.samba_add_onoff_option() implicitly
# or explicity use default=True
#
# To assist users and distributors to build Samba with the full feature
# set, the build system will abort if our dependent libraries and their
# header files are not found on the target system.  This will mean for
# example, that xattr, acl and ldap headers must be installed for the
# default build to complete.  The configure system will check for these
# headers, and the error message will indicate the option (such as
# --without-acl-support) that can be specified to skip this requirement.
#
# This will assist users and in particular distributors in building fully
# functional packages, while allowing those on systems truly without these
# facilities to continue to build Samba after careful consideration.
#
# It also ensures our container image generation in bootstrap/ is correct
# as otherwise a missing package there would just silently work

    opt.samba_add_onoff_option('winbind')
    opt.samba_add_onoff_option('ads')
    opt.samba_add_onoff_option('ldap')
    opt.samba_add_onoff_option('cups', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('iprint', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('pam')
    opt.samba_add_onoff_option('quotas', default=None)
    opt.samba_add_onoff_option('sendfile-support', default=None)
    opt.samba_add_onoff_option('utmp')
    opt.samba_add_onoff_option('avahi', with_name="enable", without_name="disable")
    opt.samba_add_onoff_option('iconv')
    opt.samba_add_onoff_option('acl-support')
    opt.samba_add_onoff_option('dnsupdate')
    opt.samba_add_onoff_option('syslog')
    opt.samba_add_onoff_option('automount')
    opt.samba_add_onoff_option('dmapi', default=None) # None means autodetection
    opt.samba_add_onoff_option('fam', default=None) # None means autodetection
    opt.samba_add_onoff_option('profiling-data', default=False)
    opt.samba_add_onoff_option('libarchive', default=True)

    opt.samba_add_onoff_option('cluster-support', default=False)

    opt.samba_add_onoff_option('regedit', default=None)
    opt.samba_add_onoff_option('winexe', default=None)

    opt.samba_add_onoff_option('fake-kaserver',
                          help=("Include AFS fake-kaserver support"), default=False)

    opt.add_option('--with-libcephfs',
                   help=("Directory under which libcephfs is installed"),
                   action="store", dest='libcephfs_dir', default=None)

    opt.samba_add_onoff_option('glusterfs', with_name="enable", without_name="disable", default=True)
    opt.samba_add_onoff_option('cephfs', with_name="enable", without_name="disable", default=True)

    opt.add_option('--enable-vxfs',
                  help=("enable support for VxFS (default=no)"),
                  action="store_true", dest='enable_vxfs', default=False)

    # default = None means autodetection
    opt.samba_add_onoff_option('spotlight', with_name="enable", without_name="disable", default=None)

def configure(conf):
    default_static_modules = []
    default_shared_modules = []
    required_static_modules = []
    forced_static_modules = []
    forced_shared_modules = []

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.developer = True

    if sys.platform != 'openbsd5':
        conf.ADD_LDFLAGS("-Wl,--export-dynamic", testflags=True)

    # We crash without vfs_default
    # and vfs_not_implemented provides helper function
    # for other modules
    required_static_modules.extend(TO_LIST('vfs_default vfs_not_implemented'))

    conf.CHECK_HEADERS('netdb.h')
    conf.CHECK_HEADERS('linux/falloc.h linux/ioctl.h')

    conf.CHECK_FUNCS('getcwd fchown chmod fchmod mknod mknodat')
    conf.CHECK_FUNCS('strtol strchr strupr chflags')
    conf.CHECK_FUNCS('getrlimit fsync setpgid')
    conf.CHECK_FUNCS('setsid glob strpbrk crypt16 getauthuid')
    conf.CHECK_FUNCS('innetgr')
    conf.CHECK_FUNCS('initgroups select poll rdchk getgrnam getgrent pathconf')
    conf.CHECK_FUNCS('setpriv setgidx setuidx setgroups syscall sysconf')
    conf.CHECK_FUNCS('atexit grantpt posix_openpt fallocate')
    conf.CHECK_FUNCS('fseeko setluid')
    conf.CHECK_FUNCS('getpwnam', headers='sys/types.h pwd.h')
    conf.CHECK_FUNCS('fdopendir')
    conf.CHECK_FUNCS('fstatat')
    conf.CHECK_FUNCS('getpwent_r setenv clearenv strcasecmp fcvt fcvtl')
    conf.CHECK_FUNCS('syslog vsyslog timegm setlocale')
    conf.CHECK_FUNCS('lutimes futimes utimensat futimens')
    conf.CHECK_FUNCS('mlock munlock mlockall munlockall')
    conf.CHECK_FUNCS('memalign posix_memalign hstrerror')
    conf.CHECK_FUNCS_IN('yp_get_default_domain', 'nsl')
    conf.CHECK_FUNCS_IN('dn_expand _dn_expand __dn_expand', 'resolv')
    conf.CHECK_FUNCS_IN('dn_expand', 'inet')
    conf.CHECK_DECLS('readahead', reverse=True, headers='fcntl.h')

    if conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
long ret = splice(0,0,1,0,400,SPLICE_F_MOVE);
''',
        'HAVE_LINUX_SPLICE',
        headers='fcntl.h'):
        conf.CHECK_DECLS('splice', reverse=True, headers='fcntl.h')

    # Check for inotify support (Skip if we are SunOS)
    #NOTE: illumos provides sys/inotify.h but is not an exact match for linux
    host_os = sys.platform
    if host_os.rfind('sunos') == -1:
        conf.CHECK_HEADERS('sys/inotify.h')
        if conf.env.HAVE_SYS_INOTIFY_H:
           conf.DEFINE('HAVE_INOTIFY', 1)

    # Check for kernel change notify support
    conf.CHECK_CODE('''
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_CHANGE_NOTIFY', addmain=False, execute=True,
        headers='fcntl.h signal.h',
        msg="Checking for kernel change notify support")

    # Check for Linux kernel oplocks
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#ifndef F_GETLEASE
#define F_GETLEASE 1025
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_GETLEASE, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_OPLOCKS_LINUX', addmain=False, execute=True,
        msg="Checking for Linux kernel oplocks")

    # Check for kernel share modes
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/file.h>
#ifndef LOCK_MAND
#define LOCK_MAND        32
#define LOCK_READ        64
#endif
main() {
        exit(flock(open("/dev/null", O_RDWR), LOCK_MAND|LOCK_READ) != 0);
}''', 'HAVE_KERNEL_SHARE_MODES', addmain=False, execute=True,
        msg="Checking for kernel share modes")

    # check for fam libs
    samba_fam_libs=None
    check_for_fam=False
    if Options.options.with_fam is None:
        check_for_fam=True
    elif Options.options.with_fam == True:
        check_for_fam=True

    if check_for_fam and conf.CHECK_HEADERS('fam.h'):
        if conf.CHECK_FUNCS_IN('FAMOpen2', 'fam'):
            samba_fam_libs='fam'
        elif conf.CHECK_FUNCS_IN('FAMOpen2', 'fam C'):
            samba_fam_libs='fam C'
        conf.CHECK_TYPE('enum FAMCodes', headers='fam.h',
            define='HAVE_FAM_H_FAMCODES_TYPEDEF',
            msg='Checking whether enum FAMCodes is available')
        conf.CHECK_FUNCS_IN('FAMNoExists', 'fam')

    if samba_fam_libs is not None:
        conf.DEFINE('SAMBA_FAM_LIBS', samba_fam_libs)
        conf.DEFINE('HAVE_FAM', 1)
    else:
        if Options.options.with_fam == True:
            conf.fatal('FAM support requested, but no suitable FAM library found')
        elif check_for_fam:
            Logs.warn('no suitable FAM library found')

    # check for libarchive (tar command in smbclient)
    # None means autodetect, True/False means enable/disable
    conf.SET_TARGET_TYPE('archive', 'EMPTY')
    if Options.options.with_libarchive is not False:
        Logs.info("Checking for libarchive existence")
        if conf.CHECK_HEADERS('archive.h') and conf.CHECK_LIB('archive', shlib=True):
            conf.CHECK_FUNCS_IN('archive_read_support_filter_all archive_read_free', 'archive')
        else:
            conf.fatal("libarchive support not found. "
                       "Try installing libarchive-dev or libarchive-devel. "
                       "Otherwise, use --without-libarchive to "
                       "build without libarchive support. "
                       "libarchive support is required for the smbclient "
                       "tar-file mode")
    elif conf.CONFIG_GET('ENABLE_SELFTEST'):
        raise Errors.WafError('libarchive library required for '
                             '--enable-selftest')


    # check for DMAPI libs
    if Options.options.with_dmapi == False:
        have_dmapi = False
    else:
        have_dmapi = True
        Logs.info("Checking for DMAPI library existence")
        samba_dmapi_lib = ''
        if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dm'):
            samba_dmapi_lib = 'dm'
        else:
            if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'jfsdm'):
                samba_dmapi_lib = 'jfsdm'
            else:
                if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dmapi'):
                    samba_dmapi_lib = 'dmapi'
                else:
                    if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'xdsm'):
                        samba_dmapi_lib = 'xdsm'
        # only bother to test headers and compilation when a candidate
        # library has been found
        if samba_dmapi_lib == '':
            have_dmapi = False
            broken_dmapi = "no suitable DMAPI library found"

        if have_dmapi:
            conf.CHECK_HEADERS('sys/dmi.h xfs/dmapi.h sys/jfsdmapi.h sys/dmapi.h dmapi.h')
            conf.CHECK_CODE('''
#include <time.h>      /* needed by Tru64 */
#include <sys/types.h> /* needed by AIX */
#ifdef HAVE_XFS_DMAPI_H
#include <xfs/dmapi.h>
#elif defined(HAVE_SYS_DMI_H)
#include <sys/dmi.h>
#elif defined(HAVE_SYS_JFSDMAPI_H)

=== third_party/wscript ===
#!/usr/bin/env python

import os
import sys
import samba_git
from waflib import Options, Errors

# work out what python external libraries we need to install
external_pkgs = {
    "iso8601": "pyiso8601/iso8601",
    }


def find_third_party_module(conf, module, package):
    conf.COMPOUND_START("Checking for third party Python module %s" % module)
    try:
        __import__(module)
    except ImportError:
        pass
    else:
        # Installed on the system
        conf.COMPOUND_END("system")

    old_path = sys.path
    try:
        sys.path.append(os.path.join(conf.path.abspath(), os.path.dirname(package)))
        try:
            __import__(module)
        except ImportError:
            if samba_git.has_submodules(conf.srcnode.abspath()):
                raise Errors.WafError("""\
Unable to find Python module '%s'. Please install the system package or check \
out the relevant submodule by running 'git submodule update --init'.
""" % module)
            else:
                raise Errors.WafError("""\
Unable to find Python module '%s'. Please install the system package or place a copy in
%s.
""" % (module, package))
        else:
            conf.COMPOUND_END("bundled")
    finally:
        sys.path = old_path


def configure(conf):
    for module, package in external_pkgs.items():
        find_third_party_module(conf, module, package)
    conf.RECURSE('cmocka')
    conf.RECURSE('popt')
    conf.RECURSE('aesni-intel')
    if conf.CONFIG_GET('ENABLE_SELFTEST'):
        conf.RECURSE('socket_wrapper')
        conf.RECURSE('nss_wrapper')
        conf.RECURSE('resolv_wrapper')
        conf.RECURSE('uid_wrapper')
        if Options.options.with_pam:
            conf.RECURSE('pam_wrapper')


def build(bld):
    if not bld.env.disable_python:
        list = []

        for module, package in external_pkgs.items():
            try:
                __import__(module)
            except ImportError:
                list.append(package)

        for e in list:
            bld.INSTALL_WILDCARD('${PYTHONARCHDIR}/samba/third_party', e + '/**/*', flat=False,
                                 exclude='*.pyc', trim_path=os.path.dirname(e))

        bld.SAMBA_GENERATOR('third_party_init_py',
                            rule='touch ${TGT}',
                            target='empty_file')

        bld.INSTALL_FILES('${PYTHONARCHDIR}/samba/third_party', 'empty_file', destname='__init__.py')

    bld.RECURSE('cmocka')
    bld.RECURSE('popt')
    bld.RECURSE('aesni-intel')
    if bld.CONFIG_GET('SOCKET_WRAPPER'):
        bld.RECURSE('socket_wrapper')
    if bld.CONFIG_GET('NSS_WRAPPER'):
        bld.RECURSE('nss_wrapper')
    if bld.CONFIG_GET('RESOLV_WRAPPER'):
        bld.RECURSE('resolv_wrapper')
    if bld.CONFIG_GET('UID_WRAPPER'):
        bld.RECURSE('uid_wrapper')
    if bld.CONFIG_GET('PAM_WRAPPER'):
        bld.RECURSE('pam_wrapper')

=== lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
VERSION = '2.2.2'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Errors, Options, Logs, Context
import shutil

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent
                        third_party/popt:third_party/popt
                        third_party/cmocka:third_party/cmocka
                        buildtools:buildtools third_party/waf:third_party/waf''')

samba_dist.DIST_FILES('''lib/util/binsearch.h:lib/util/binsearch.h
                         lib/util/attr.h:lib/util/attr.h''')

def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.load('python') # options for disabling pyc or pyo compilation

    opt.add_option('--without-ldb-lmdb',
                   help='disable new LMDB backend for LDB',
                   action='store_true', dest='without_ldb_lmdb', default=False)


def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        conf.RECURSE('third_party/cmocka')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

        if not conf.CHECK_CMOCKA():
            raise Errors.WafError('cmocka development package have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_CMOCKA', 1)

    conf.RECURSE('lib/replace')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        max_ldb_version = [int(x) for x in VERSION.split(".")]
        max_ldb_version[2] = 999
        max_ldb_version_dots = "%d.%d.%d" % tuple(max_ldb_version)

        if conf.env.disable_python:
            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent',
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)
        else:
            using_system_pyldb_util = True
            dflt_name = 'pyldb-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(dflt_name,
                                                 minversion=VERSION,
                                                 maxversion=max_ldb_version_dots,
                                                 onlyif='talloc tdb tevent',
                                                 implied_deps='replace talloc tdb tevent ldb'):
                using_system_pyldb_util = False

            if using_system_pyldb_util:
                conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent %s' % dflt_name,
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)

    if not conf.CHECK_CODE('return !(sizeof(size_t) >= 8)',
                           "HAVE_64_BIT_SIZE_T_FOR_LMDB",
                           execute=True,
                           msg='Checking for a 64-bit host to '
                           'support lmdb'):
        Logs.warn("--without-ldb-lmdb implied as this "
                  "host is not 64-bit")

        if not conf.env.standalone_ldb and \
           not Options.options.without_ad_dc and \
           conf.CONFIG_GET('ENABLE_SELFTEST'):
            Logs.warn("NOTE: Some AD DC parts of selftest will fail")

        conf.env.REQUIRE_LMDB = False
    else:
        if conf.env.standalone_ldb:
            if Options.options.without_ldb_lmdb:
                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True
        elif Options.options.without_ad_dc:
            conf.env.REQUIRE_LMDB = False
        else:
            if Options.options.without_ldb_lmdb:
                if not Options.options.without_ad_dc and \
                   conf.CONFIG_GET('ENABLE_SELFTEST'):
                    raise Errors.WafError('--without-ldb-lmdb conflicts '
                                         'with --enable-selftest while '
                                         'building the AD DC')

                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True


    if conf.CONFIG_SET('USING_SYSTEM_LDB'):
        v = VERSION.split('.')
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MAJOR', int(v[0]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MINOR', int(v[1]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_RELEASE', int(v[2]))

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if not sys.platform.startswith("openbsd"):
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    # if lmdb support is enabled then we require lmdb
    # is present, build the mdb back end and enable lmdb support in
    # the tools.
    if conf.env.REQUIRE_LMDB and \
       not conf.CONFIG_SET('USING_SYSTEM_LDB'):
        if not conf.CHECK_CFG(package='lmdb',
                              args='"lmdb >= 0.9.16" --cflags --libs',
                              msg='Checking for lmdb >= 0.9.16',
                              mandatory=False):
            if not conf.CHECK_CODE('''
                    #if MDB_VERSION_MAJOR == 0 \
                      && MDB_VERSION_MINOR <= 9 \
                      && MDB_VERSION_PATCH < 16
                    #error LMDB too old
                    #endif
                    ''',
                    'HAVE_GOOD_LMDB_VERSION',
                    headers='lmdb.h',
                    msg='Checking for lmdb >= 0.9.16 via header check'):

                if conf.env.standalone_ldb:
                    raise Errors.WafError('ldb build (unless --without-ldb-lmdb) '
                                         'requires '
                                         'lmdb 0.9.16 or later')
                elif not Options.options.without_ad_dc:
                    raise Errors.WafError('Samba AD DC and --enable-selftest '
                                         'requires '
                                         'lmdb 0.9.16 or later')

        if conf.CHECK_FUNCS_IN('mdb_env_create', 'lmdb', headers='lmdb.h'):
            conf.DEFINE('HAVE_LMDB', '1')
            conf.env.HAVE_LMDB = True


    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')

    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')
        bld.RECURSE('third_party/cmocka')

    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        if not 'PACKAGE_VERSION' in bld.env:
            bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True
    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    if bld.PYTHON_BUILD_IS_ENABLED():
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            name = bld.pyembed_libname('pyldb-util')
            bld.SAMBA_LIBRARY(name,
                              deps='replace ldb',
                              source='pyldb_util.c',
                              public_headers=('' if private_library else 'pyldb.h'),
                              public_headers_install=not private_library,
                              vnum=VERSION,
                              private_library=private_library,
                              pc_files='pyldb-util.pc',
                              pyembed=True,
                              enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                              abi_directory='ABI',
                              abi_match='pyldb_*')

            if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
                bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                                 deps='replace ldb ' + name,
                                 realname='ldb.so',
                                 cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        # Do only install this file as part of the Samba build if we do not
        # use the system libldb!
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            bld.SAMBA_SCRIPT('_ldb_text.py',
                             pattern='_ldb_text.py',
                             installdir='python')

            bld.INSTALL_FILES('${PYTHONARCHDIR}', '_ldb_text.py')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if bld.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        ldb_headers = ('include/ldb.h include/ldb_errors.h '
                       'include/ldb_module.h include/ldb_handlers.h')

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN replace',
                          includes='include',
                          public_headers=('' if private_library else ldb_headers),
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
                          manpages='man/ldb.3',

=== lib/mscat/wscript ===
#!/usr/bin/env python

import os
import sys
from waflib import Logs

def configure(conf):
    pkg_name = 'libtasn1'
    pkg_minversion = '3.8'

    if conf.CHECK_BUNDLED_SYSTEM_PKG(pkg_name, minversion=pkg_minversion):
        if not conf.find_program('asn1Parser', var='ASN1PARSER'):
            Logs.warn('WARNING: ans1Parser hasn\'t been found! Please install it (e.g. libtasn1-bin)')

def build(bld):
    if (bld.CONFIG_SET('HAVE_LIBTASN1') and
        bld.env.ASN1PARSER and
        bld.CONFIG_SET('HAVE_GNUTLS_PKCS7_GET_EMBEDDED_DATA_OID')):

        bld.SAMBA_GENERATOR('MSCAT_PARSER',
                            source='mscat.asn',
                            target='mscat_asn1_tab.c',
                            rule='${ASN1PARSER} --output ${TGT} ${SRC}',
                            group='build_source')

        bld.SAMBA_LIBRARY('mscat',
                          source='''
                                 mscat_asn1_tab.c
                                 mscat_ctl.c
                                 mscat_pkcs7.c
                                 ''',
                          deps='''
                               talloc
                               gnutls
                               libtasn1
                               samba-util
                               ''',
                          private_library=True)

        bld.SAMBA_BINARY('dumpmscat',
                         source='dumpmscat.c',
                         deps='mscat')

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

import sys
import os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist
from waflib import Options, Utils, Logs, Context

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('sys/unistd.h alloca.h float.h')

    conf.SET_TARGET_TYPE('tirpc', 'EMPTY')

    if conf.CHECK_CODE(
            '\n#ifndef _TIRPC_RPC_H\n#error "no tirpc headers in system path"\n#endif\n',
            'HAVE_RPC_RPC_HEADERS',
            headers=['rpc/rpc.h', 'rpc/nettype.h'],
            msg='Checking for tirpc rpc headers in default system path'):
        if conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            conf.undefine('HAVE_RPC_RPC_H')

    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libtirpc', args='--cflags --libs',
                       msg='Checking for libtirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libntirpc', args='--cflags',
                       msg='Checking for libntirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            Logs.warn('No rpc/rpc.h header found, tirpc or libntirpc missing?')

    conf.SET_TARGET_TYPE('nsl', 'EMPTY')
    conf.CHECK_HEADERS('rpc/rpc.h rpcsvc/yp_prot.h', lib='tirpc')
    if not conf.CONFIG_SET('HAVE_RPCSVC_YP_PROT_H'):
        if conf.CHECK_CFG(package='libnsl', args='--cflags --libs',
                          msg='Checking for libnsl',
                          uselib_store='NSL'):
            conf.SET_TARGET_TYPE('nsl', 'SYSLIB')
            conf.CHECK_HEADERS('rpc/rpc.h rpcsvc/yp_prot.h', lib='tirpc nsl')
        else:
            conf.SET_TARGET_TYPE('nsl', 'SYSLIB')
    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h', lib='tirpc nsl')

    # This file is decprecated with glibc >= 2.30 so we need to check if it
    # includes a deprecation warning:
    # #warning "The <sys/sysctl.h> header is deprecated and will be removed."
    conf.CHECK_CODE('''
                    #include <sys/sysctl.h>
                    int main(void) { return 0; }
                    ''',
                    define='HAVE_SYS_SYSCTL_H',
                    cflags=['-Werror=cpp'],
                    addmain=False,
                    msg='Checking for header sys/sysctl.h')

    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h')
    conf.CHECK_HEADERS('valgrind/memcheck.h valgrind/helgrind.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h stdatomic.h')
    conf.CHECK_HEADERS('libgen.h')

    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-function'):
        conf.define('HAVE_WNO_UNUSED_FUNCTION', '1')

    if conf.CHECK_CFLAGS('-Wno-strict-overflow'):
        conf.define('HAVE_WNO_STRICT_OVERFLOW', '1')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    addmain=False,
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    # Those functions are normally available in libc
    if not conf.CHECK_FUNCS('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h'):
        conf.CHECK_FUNCS_IN('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            'socket nsl',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')
        conf.DEFINE('REPLACE_REQUIRES_LIBSOCKET_LIBNSL', 1)

    conf.CHECK_FUNCS('memset_s memset_explicit')

    conf.CHECK_CODE('''
                    #include <string.h>

                    int main(void)
                    {
                        char buf[] = "This is some content";
                        memset(buf, '\0', sizeof(buf)); __asm__ volatile("" : : "g"(&buf) : "memory");
                        return 0;
                    }
                    ''',
                    define='HAVE_GCC_VOLATILE_MEMORY_PROTECTION',
                    addmain=False,
                    msg='Checking for volatile memory protection',
                    local_include=False)

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);

=== lib/talloc/wscript ===
#!/usr/bin/env python

APPNAME = 'talloc'
VERSION = '2.3.1'

import os
import sys

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Logs, Options, Context

# setup what directories to put in a tarball
samba_dist.DIST_DIRS("""lib/talloc:. lib/replace:lib/replace
buildtools:buildtools third_party/waf:third_party/waf""")


def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('talloc', noextension='talloc')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--enable-talloc-compat1',
                       help=("Build talloc 1.x.x compat library [False]"),
                       action="store_true", dest='TALLOC_COMPAT1', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()

    conf.define('TALLOC_BUILD_VERSION_MAJOR', int(VERSION.split('.')[0]))
    conf.define('TALLOC_BUILD_VERSION_MINOR', int(VERSION.split('.')[1]))
    conf.define('TALLOC_BUILD_VERSION_RELEASE', int(VERSION.split('.')[2]))

    conf.env.TALLOC_COMPAT1 = False
    if conf.env.standalone_talloc:
        conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1
        conf.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        conf.env.TALLOC_VERSION = VERSION

    conf.CHECK_XSLTPROC_MANPAGES()

    conf.CHECK_HEADERS('sys/auxv.h')
    conf.CHECK_FUNCS('getauxval')

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    if not conf.env.standalone_talloc:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('talloc', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TALLOC', 1)

        if conf.env.disable_python:
            using_system_pytalloc_util = False
        else:
            using_system_pytalloc_util = True
            name = 'pytalloc-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(name, minversion=VERSION,
                                                 implied_deps='talloc replace'):
                using_system_pytalloc_util = False

        if using_system_pytalloc_util:
            conf.define('USING_SYSTEM_PYTALLOC_UTIL', 1)


def build(bld):
    bld.RECURSE('lib/replace')

    if bld.env.standalone_talloc:
        private_library = False

        # should we also install the symlink to libtalloc1.so here?
        bld.SAMBA_LIBRARY('talloc-compat1-%s' % (VERSION),
                          'compat/talloc_compat1.c',
                          public_deps='talloc',
                          soname='libtalloc.so.1',
                          pc_files=[],
                          public_headers=[],
                          enabled=bld.env.TALLOC_COMPAT1)

        testsuite_deps = 'talloc'
        if bld.CONFIG_SET('HAVE_PTHREAD'):
            testsuite_deps += ' pthread'

        bld.SAMBA_BINARY('talloc_testsuite',
                         'testsuite_main.c testsuite.c',
                         testsuite_deps,
                         install=False)

        bld.SAMBA_BINARY('talloc_test_magic_differs_helper',
                         'test_magic_differs_helper.c',
                         'talloc', install=False)

    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TALLOC'):

        bld.SAMBA_LIBRARY('talloc',
                          'talloc.c',
                          deps='replace',
                          abi_directory='ABI',
                          abi_match='talloc* _talloc*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers=('' if private_library else 'talloc.h'),
                          pc_files='talloc.pc',
                          public_headers_install=not private_library,
                          private_library=private_library,
                          manpages='man/talloc.3')

    if not bld.CONFIG_SET('USING_SYSTEM_PYTALLOC_UTIL'):
        name = bld.pyembed_libname('pytalloc-util')

        bld.SAMBA_LIBRARY(name,
                source='pytalloc_util.c',
                public_deps='talloc',
                pyembed=True,
                vnum=VERSION,
                hide_symbols=True,
                abi_directory='ABI',
                abi_match='pytalloc_* _pytalloc_*',
                private_library=private_library,
                public_headers=('' if private_library else 'pytalloc.h'),
                pc_files='pytalloc-util.pc',
                enabled=bld.PYTHON_BUILD_IS_ENABLED()
                )
        bld.SAMBA_PYTHON('pytalloc',
                         'pytalloc.c',
                         deps='talloc ' + name,
                         enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                         realname='talloc.so')

        bld.SAMBA_PYTHON('test_pytalloc',
                         'test_pytalloc.c',
                         deps=name,
                         enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                         realname='_test_pytalloc.so',
                         install=False)


def testonly(ctx):
    '''run talloc testsuite'''
    import samba_utils

    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared')
    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared/private')

    cmd = os.path.join(Context.g_module.out, 'talloc_testsuite')
    ret = samba_utils.RUN_COMMAND(cmd)
    print("testsuite returned %d" % ret)
    magic_helper_cmd = os.path.join(Context.g_module.out, 'talloc_test_magic_differs_helper')
    magic_cmd = os.path.join(Context.g_module.top, 'lib', 'talloc',
                             'test_magic_differs.sh')
    if not os.path.exists(magic_cmd):
        magic_cmd = os.path.join(Context.g_module.top, 'test_magic_differs.sh')

    magic_ret = samba_utils.RUN_COMMAND(magic_cmd + " " +  magic_helper_cmd)
    print("magic differs test returned %d" % magic_ret)
    pyret = samba_utils.RUN_PYTHON_TESTS(['test_pytalloc.py'])
    print("python testsuite returned %d" % pyret)
    sys.exit(ret or magic_ret or pyret)

# WAF doesn't build the unit tests for this, maybe because they don't link with talloc?
# This forces it
def test(ctx):
    Options.commands.append('build')
    Options.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    samba_utils.reconfigure(ctx)


def pydoctor(ctx):
    '''build python apidocs'''
    cmd='PYTHONPATH=bin/python pydoctor --project-name=talloc --project-url=http://talloc.samba.org/ --make-html --docformat=restructuredtext --introspect-c-modules --add-module bin/python/talloc.*'
    print("Running: %s" % cmd)
    os.system(cmd)

=== libcli/smb/wscript ===
#!/usr/bin/env python


def build(bld):
    bld.SAMBA_LIBRARY('smb_transport',
        source='''
            read_smb.c
        ''',
        deps='LIBASYNC_REQ',
        public_deps='talloc tevent',
        private_library=True,
        private_headers='''
            read_smb.h
        ''',
        )

    bld.SAMBA_LIBRARY('cli_smb_common',
    source='''
           smb_signing.c
           smb_seal.c
           smb2_negotiate_context.c
           smb2_create_blob.c smb2_signing.c
           smb2_lease.c
           util.c
           smbXcli_base.c
           smb1cli_trans.c
           smb1cli_echo.c
           smb1cli_create.c
           smb1cli_session.c
           smb1cli_close.c
           smb1cli_write.c
           smb1cli_read.c
           smb2cli_session.c
           smb2cli_tcon.c
           smb2cli_create.c
           smb2cli_close.c
           smb2cli_read.c
           smb2cli_write.c
           smb2cli_flush.c
           smb2cli_set_info.c
           smb2cli_query_info.c
           smb2cli_notify.c
           smb2cli_query_directory.c
           smb2cli_ioctl.c
           smb2cli_echo.c
           smb2_posix.c
           tstream_smbXcli_np.c
    ''',
    deps='''
        LIBCRYPTO gnutls NDR_SMB2_LEASE_STRUCT samba-errors gensec krb5samba
        smb_transport GNUTLS_HELPERS
    ''',
    public_deps='talloc samba-util iov_buf',
    private_library=True,
    private_headers='''
                    smb_common.h
                    smb2_constants.h
                    smb_constants.h
                    smb_signing.h
                    smb_seal.h
                    smb2_create_blob.h
                    smb2_signing.h
                    smb2_lease.h
                    smb_util.h
                    smb_unix_ext.h
                    smb_posix.h
                    tstream_smbXcli_np.h
    ''',
    )

    bld.SAMBA_BINARY('test_smb1cli_session',
                     source='test_smb1cli_session.c',
                     deps='cmocka cli_smb_common',
                     for_selftest=True)

=== debian/changelog ===
samba (2:4.13.13+dfsg-1~deb11u6) bullseye-security; urgency=medium

  * CVE-2022-2127: Out-of-bounds read in winbind AUTH_CRAP
  * CVE-2022-3437: Heimdal des/des3 heap-based buffer overflow
  * CVE-2023-4091: Client can truncate files even with read-only permissions
  * CVE-2023-34966: Spotlight mdssvc RPC Request Infinite Loop
    Denial-of-Service Vulnerability
  * CVE-2023-34967: Spotlight mdssvc RPC Request Type Confusion
    Denial-of-Service Vulnerability
  * CVE-2023-34968: Spotlight server-side Share Path Disclosure

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 19 Mar 2024 18:00:18 -0300

samba (2:4.13.13+dfsg-1~deb11u5) bullseye-security; urgency=medium

  * 3 patches:
    - CVE-2022-32742-bug-15085-4.13.patch
    - kpasswd_bugs_v15_4-13.patch
    - ldb-memory-bug-15096-4.13-v3.patch
    fixing:
    o CVE-2022-2031: Samba AD users can bypass certain restrictions associated
      with changing passwords.
      https://www.samba.org/samba/security/CVE-2022-2031.html
    o CVE-2022-32742: Server memory information leak via SMB1.
      https://www.samba.org/samba/security/CVE-2022-32742.html
    o CVE-2022-32744: Samba AD users can forge password change requests
      for any user.
      https://www.samba.org/samba/security/CVE-2022-32744.html
    o CVE-2022-32745: Samba AD users can crash the server process with an LDAP
      add or modify request.
      https://www.samba.org/samba/security/CVE-2022-32745.html
    o CVE-2022-32746: Samba AD users can induce a use-after-free in the server
      process with an LDAP add or modify request.
      https://www.samba.org/samba/security/CVE-2022-32746.html
   * Closes: #1016449, CVE-2022-2031 CVE-2022-32742, CVE-2022-32744,
     CVE-2022-32745, CVE-2022-32746
   * Build-Depend on libldb-dev >= 2.2.3-2~deb11u2
     (which includes the new symbols in libldb used by this update)
   * d/rules: use dpkg-query instead of pkg-config to find debian package
     version of libldb-dev, since this is what we actually want, not the
     internal version libldb thinks it is at.

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 10 Aug 2022 00:19:38 +0300

samba (2:4.13.13+dfsg-1~deb11u4) bullseye-proposed-updates; urgency=medium

  * fix the order of everything during build by exporting PYTHONHASHSEED=1
    for waf.  This should fix the broken i386 build of the last security
    upload. Closes: #1006935, #1009855
  * Import the left-over patches from 4.13.17 upstream stable branch:
   - s3-winbindd-fix-allow-trusted-domains-no-regression.patch
     https://bugzilla.samba.org/show_bug.cgi?id=14899
     Closes: #999876, winbind fails to start with `allow trusted domains: no`
   - IPA-DC-add-missing-checks.patch
     https://bugzilla.samba.org/show_bug.cgi?id=14903
   - CVE-2020-25717-s3-auth-fix-MIT-Realm-regression.patch
     https://bugzilla.samba.org/show_bug.cgi?id=14922
     Closes: #1001053, MIT-kerberos auth broken after 4.13.13+dfsg-1~deb11u2
   - dsdb-Use-DSDB_SEARCH_SHOW_EXTENDED_DN-when-searching.patch
     https://bugzilla.samba.org/show_bug.cgi?id=14656
     https://bugzilla.samba.org/show_bug.cgi?id=14902
   - s3-smbd-Fix-mkdir-race-condition-allows-share-escape.patch
     https://bugzilla.samba.org/show_bug.cgi?id=13979
     Closes: #1004691, CVE-2021-43566: mkdir race condition allows share escape
  * 4 patches from upstream to fix possible serious data corruption issue
    with windows client cache poisoning, Closes: #1005642
    https://bugzilla.samba.org/show_bug.cgi?id=14928
  * two patches from upstream to fix coredump when connecting to shares
    with var substitutions, Closes: #998423
    https://bugzilla.samba.org/show_bug.cgi?id=14809
  * samba-common-bin.postinst: mkdir /run/samba before invoking samba binaries
    Closes: #953530
  * remove file creation+deletion from previously applied combined patches
    CVE-2021-23192-only-4.13-v2.patch & CVE-2021-3738-dsdb-crash-4.13-v03.patch
    to make patch deapply happy (quilt does not notice this situation)
  * d/salsa-ci.yml: target bullseye

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 28 May 2022 22:52:59 +0300

samba (2:4.13.13+dfsg-1~deb11u3) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add patches for CVE-2022-0336 (Closes: #1004694)
    - CVE-2022-0336: pytest: Add a test for an SPN conflict with a re-added
      SPN.
    - CVE-2022-0336: s4/dsdb/samldb: Don't return early when an SPN is
      re-added to an object.
  * Add patches for CVE-2021-44142 (Closes: #1004693)
    - CVE-2021-44142: libadouble: add defines for icon lengths.
    - CVE-2021-44142: smbd: add Netatalk xattr used by vfs_fruit to the list
      of private Samba xattrs.
    - CVE-2021-44142: libadouble: harden ad_unpack_xattrs()
    - CVE-2021-44142: libadouble: add basic cmocka tests.
    - CVE-2021-44142: libadouble: harden parsing code.
  * Add patches to address "The CVE-2020-25717 username map [script] advice
    has undesired side effects for the local nt token" (Closes: #1001068)
    - CVE-2020-25727: idmap_nss: verify that the name of the sid belongs to
      the configured domain
    - CVE-2020-25717: tests/krb5: Add method to automatically obtain server
      credentials
    - CVE-2020-25717: nsswitch/nsstest.c: Lower 'non existent uid' to make
      room for new accounts
    - CVE-2020-25717: selftest: turn ad_member_no_nss_wb into
      ad_member_idmap_nss
    - CVE-2020-25717: tests/krb5: Add a test for idmap_nss mapping users to
      SIDs
    - CVE-2020-25717: s3:auth: Fallback to a SID/UID based mapping if the
      named based lookup fails

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 03 Feb 2022 21:54:02 +0100

samba (2:4.13.13+dfsg-1~deb11u2) bullseye-security; urgency=high

  * This is a security release in order to address the following defects:
    - CVE-2016-2124: don't fallback to non spnego authentication if we require
      kerberos
    - MS CVE-2020-17049 in Samba: 'Bronze bit' S4U2Proxy Constrained Delegation
      bypass


=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Andrew Bartlett <abartlet+debian@catalyst.net.nz>
Homepage: http://www.samba.org
Standards-Version: 4.5.0
Build-Depends: bison,
               debhelper-compat (= 13),
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               flex,
               libacl1-dev,
               libarchive-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libblkid-dev,
               libbsd-dev,
               libcap-dev [linux-any],
               libcephfs-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ppc64 s390x x32],
               libcmocka-dev (>= 1.1.3),
               libcups2-dev,
               libdbus-1-dev,
               libglusterfs-dev [linux-any],
               libgnutls28-dev,
               libgpgme11-dev,
               libicu-dev,
               libjansson-dev,
               libldap2-dev,
               libldb-dev (>= 2:2.2.3-2~deb11u2~),
               libncurses5-dev,
               libpam0g-dev,
               libparse-yapp-perl,
               libpcap-dev [hurd-i386 kfreebsd-any],
               libpopt-dev,
               librados-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ppc64 s390x x32],
               libreadline-dev,
               libsystemd-dev [linux-any],
               libtalloc-dev (>= 2.3.1~),
               libtasn1-6-dev (>= 3.8),
               libtasn1-bin,
               libtdb-dev (>= 1.4.3~),
               libtevent-dev (>= 0.10.2~),
               liburing-dev [linux-any],
               perl,
               pkg-config,
               po-debconf,
               python3-dev,
               python3-dnspython,
               python3-etcd,
               python3-ldb (>= 2:2.2.3~),
               python3-ldb-dev (>= 2:2.2.3~),
               python3-talloc-dev (>= 2.3.1~),
               python3-tdb (>= 1.4.3~),
               python3-testtools,
               python3,
               xfslibs-dev [linux-any],
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Build-Conflicts: libtracker-miner-2.0-dev,
                 libtracker-sparql-2.0-dev
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: adduser,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         lsb-base (>= 4.1+Debian),
         procps,
         python3,
         python3-dnspython,
         python3-samba,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr,
            logrotate,
            python3-markdown,
            samba-dsdb-modules,
            samba-vfs-modules
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ctdb,
          ldb-tools,
          ntp | chrony (>= 3.0-1),
          smbldap-tools,
          ufw,
          winbind
Enhances: bind9, ntp
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an NT4-style domain controller, and can integrate with both NT4 domains
 and Active Directory realms as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 or Active Directory domain controller.
 For use in an NT4 domain or Active Directory realm, you will also need the
 winbind package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libndr-standard0 (<< 2:4.0.9),
        libsamba-credentials0 (<< 2:4.0.9),
        libsamba-hostconfig0 (<< 2:4.0.9),
        libsamba-util0 (<< 2:4.0.9),
        sssd-ad-common (<< 2.3.0),
Replaces: samba (<< 2:4.3.3+dfsg-1),
          libndr-standard0 (<< 2:4.0.9),
          libsamba-credentials0 (<< 2:4.0.9),
          libsamba-hostconfig0 (<< 2:4.0.9),
          libsamba-util0 (<< 2:4.0.9),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python3,
         python3-samba,
         samba-common (=${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: samba-dsdb-modules
Suggests: heimdal-clients,
          python3-markdown,
          python3-dnspython
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.6~)
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev (>= 2:2),
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: python3-samba
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Provides: ${python3:Provides}
Depends: python3-ldb,
         python3-tdb,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-gpg
Description: Python 3 bindings for Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains Python 3 bindings for most Samba libraries.

Package: samba-dsdb-modules
Architecture: any
Multi-Arch: same
Section: libs
Depends: libgpgme11,
         samba-libs (= ${binary:Version}),
         ${ldb:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: libldb2
Description: Samba Directory Services Database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains LDB plugins which add support for various Active
 Directory features to the LDB library.

Package: samba-vfs-modules
Architecture: any
Multi-Arch: same
Breaks: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Replaces: samba (<< 2:4.3.2+dfsg-1), samba-libs (<< 2:4.3.2+dfsg-1)
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: ${vfsceph:Recommends}, ${vfsglusterfs:Recommends}, ${vfssnapper:Recommends}
Enhances: samba
Description: Samba Virtual FileSystem plugins
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 Virtual FileSystem modules are stacked shared libraries extending the
 functionality of Samba. Some examples are:
  * vfs_acl_xattr: Save NTFS-ACLs in Extended Attributes
  * vfs_audit: record selected Samba VFS operations in the system log
  * vfs_readonly: Make a Samba share read only for a specified time period
  * vfs_recycle: Give the same effect as the Recycle Bin on Windows computers
  * vfs_shadow_copy2: Expose snapshots to Windows clients as shadow copies
  * vfs_worm: Disallow writes for older file
 .
 Note: The runtime dependencies of vfs_ceph, vfs_glusterfs and vfs_snapper are
 moved to Recommends.

Package: libsmbclient
Section: libs
Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

LDB_VERSION = $(shell dpkg-query -f '$${Version}' -W libldb-dev | sed 's/-.*//')
LDB_NEXT_VERSION = $(shell python3 -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print('.'.join(x))")
# samba ships ldb modules, which are specific to the ldb version, so we need a
# strict dependency on the upstream ldb version
# this also mean samba needs a rebuild when the upstream ldb version changes
LDB_DEPENDS = "libldb2 (<< $(LDB_NEXT_VERSION)~), libldb2 (>> $(LDB_VERSION)~)"
export PYSHORT=python3
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"
WAF := PYTHONHASHSEED=1 $(PYTHON) ./buildtools/bin/waf -v
WAF_NO_PARALLEL := $(WAF) -j 1

# wrapper around cups-config, to work around #726726
export PATH:=$(CURDIR)/debian/bin:$(PATH)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

conf_args = \
		--prefix=/usr \
		--enable-fhs \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--libexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-privatedir=/var/lib/samba/private \
		--with-smbpasswd-file=/etc/samba/smbpasswd \
		--with-piddir=/run/samba \
		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
		--with-pam \
		--with-syslog \
		--with-utmp \
		--with-winbind \
		--with-quota \
		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4,vfs_nfs4acl_xattr \
		--with-automount \
		--with-ldap \
		--with-ads \
		--with-dnsupdate \
		--with-gpgme \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
		--datadir=/usr/share \
		--with-lockdir=/run/samba \
		--with-statedir=/var/lib/samba \
		--with-cachedir=/var/cache/samba \
		--enable-avahi \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser,roken,replace,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
		--builtin-libraries=ccan,samba-cluster-support \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--with-cluster-support \
		--with-socketpath=/run/ctdb/ctdbd.socket \
		--with-logdir=/var/log/ctdb \
		--enable-etcd-reclock \
		--enable-spotlight


WITH_CEPH = yes
# Ceph is not available on all platforms
ifeq (,$(filter amd64 arm64 armel armhf i386 mips64el mipsel ppc64el ppc64 s390x x32, $(DEB_HOST_ARCH)))
    WITH_CEPH = no
endif
# Ubuntu i386 binary compatibility only effort: No Ceph
ifeq ($(DEB_VENDOR) $(DEB_HOST_ARCH), Ubuntu i386)
    WITH_CEPH = no
endif

ifeq ($(WITH_CEPH), yes)
	conf_args += \
		--enable-ceph-reclock
else
	conf_args += \
		--disable-cephfs
endif


WITH_GLUSTERFS = yes
# GlusterFS is linux-only
ifneq ($(DEB_HOST_ARCH_OS), linux)
    WITH_CEPH = no
endif
# GlusterFS is not in Ubuntu main
ifeq ($(DEB_VENDOR), Ubuntu)
    WITH_GLUSTERFS = no
endif


ifeq ($(DEB_HOST_ARCH_OS), linux)
	conf_args += \
		--with-systemd \
		--systemd-install-services \
		--with-systemddir=/lib/systemd/system
else
	conf_args += \
		--without-systemd
endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages
ifeq ($(DEB_VENDOR) $(DEB_HOST_ARCH), Ubuntu i386)
	BUILD_PACKAGES += \
		-Nctdb \
		-Nlibpam-winbind \
		-Nsamba \
		-Nsamba-testsuite
endif

%:
	dh $* --with python3 $(BUILD_PACKAGES)

override_dh_auto_configure:
	$(WAF_NO_PARALLEL) configure $(conf_args)

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install
	# get list of files in build log
	find ${DESTDIR}
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.*
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already documented in debian/copyright
	-rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	# pam stuff
	mkdir -p $(DESTDIR)/usr/share/pam-configs
	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	# we don't ship the symlinks
	rm $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_*.so
	#Remove unused vfstest manpage vfstest is no longer installed
	rm $(DESTDIR)/usr/share/man/man1/vfstest.1
	# Debian goodies to set global option in smb.conf and add a share
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Debian goodies
	cp debian/smb.conf* $(DESTDIR)/usr/share/samba/
	install -m755 debian/panic-action $(DESTDIR)/usr/share/samba/panic-action
	install -m755 debian/update-apparmor-samba-profile $(DESTDIR)/usr/share/samba/update-apparmor-samba-profile
	cp debian/gdbcommands $(DESTDIR)/etc/samba/
	mkdir -p $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d
	install -m755 debian/samba-common.dhcp $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d/samba
	install -m 0755 debian/mksmbpasswd.awk $(DESTDIR)/usr/sbin/mksmbpasswd
	mkdir -p $(DESTDIR)/etc/ufw/applications.d
	install -m644 debian/samba.ufw.profile $(DESTDIR)/etc/ufw/applications.d/samba
	mkdir -p $(DESTDIR)/usr/share/apport/package-hooks
	install -D -m 644 debian/source_samba.py $(DESTDIR)/usr/share/apport/package-hooks/source_samba.py
	# Install other stuff not installed by "make install"
	# This moves the dckeytab module to the samba package in order to avoid
	# a circular dependency between python3-samba, samba and samba-common-bin
	mkdir -p debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba
	mv $(DESTDIR)/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab*.so \
	   debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba/
	# use upstream version of smb.conf.5 if there is no built version
	# this is a temporary workaround for #750593 in xsltproc
	[ -e $(DESTDIR)/usr/share/man/man5/smb.conf.5 ] || \
	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
	# Tests that shouldn't be installed
	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
	# Remove ctdb tests
	rm $(DESTDIR)/usr/bin/ctdb_run_tests
	rm $(DESTDIR)/usr/bin/ctdb_run_cluster_tests
	rm -r $(DESTDIR)/usr/lib/*/ctdb/tests
	rm -r $(DESTDIR)/usr/share/ctdb/tests
ifeq ($(DEB_HOST_ARCH_OS), linux)
	# Install systemd configs
	mkdir -p $(DESTDIR)/lib/systemd/system/
	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
	# Services fixups
	mv $(DESTDIR)/lib/systemd/system/nmb.service $(DESTDIR)/lib/systemd/system/nmbd.service
	mv $(DESTDIR)/lib/systemd/system/smb.service $(DESTDIR)/lib/systemd/system/smbd.service
	mv $(DESTDIR)/lib/systemd/system/samba.service $(DESTDIR)/lib/systemd/system/samba-ad-dc.service
	sed -i \
	  -e 's|/etc/sysconfig/|/etc/default/|' \
	  -e 's|nmb\.service|nmbd.service|' \
	  -e 's|smb\.service|smbd.service|' \
	  -e 's|samba\.service|samba-ad-dc.service|' \
	  $(DESTDIR)/lib/systemd/system/nmbd.service \
	  $(DESTDIR)/lib/systemd/system/samba-ad-dc.service \
	  $(DESTDIR)/lib/systemd/system/smbd.service \
	  $(DESTDIR)/lib/systemd/system/winbind.service
endif

=== debian/watch ===
version=3
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d*$//,pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress" \
	  https://download.samba.org/pub/samba/ samba-(4\.13\..*).tar.gz
